unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, odbcconn, sqldb, db, FileUtil, LResources, Forms, Controls,
  Graphics, Dialogs, DBGrids, DbCtrls, StdCtrls, Printers, PrintersDlgs;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Datasource1: TDatasource;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBGrid1: TDBGrid;
    ODBCConnection1: TODBCConnection;
    PrintDialog1: TPrintDialog;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormShow(Sender: TObject);
    procedure SQLQuery1AfterOpen(DataSet: TDataSet);
  private
    { private declarations }
    procedure PrintDbGrid(dbGrid:TdbGrid);
    procedure Text_von_DB_umwandeln(Sender: TField; var aText: string; DisplayText: BOOLEAN);
    procedure Text_nach_DB_umwandeln(Sender: TField; const aText: string);
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  //connection
  ODBCConnection1.Driver:= 'Microsoft Access Driver (*.mdb)';
  ODBCConnection1.Params.Add('DBQ=' + ExtractFilePath(Application.ExeName) + 'Database1.mdb');
  ODBCConnection1.Connected:= True;
  ODBCConnection1.KeepConnection := True;

  SQLTransaction1.DataBase := ODBCConnection1;
  SQLTransaction1.Action := caCommit;
  SQLTransaction1.Active := false; //not applied to ms access(false) bei true kommt fehler das die transaktion schon aktiv ist
  SQLTransaction1.StartTransaction;

  SQLQuery1.DataBase := ODBCConnection1;
  SQLQuery1.UsePrimaryKeyAsKey := False;
  SQLQuery1.Filtered:=True;  //Jetzt kann ein Filter gesetzt werden  ID=1
  SQLQuery1.SQL.Text := 'SELECT * FROM table1';
  //SQLQuery1.Open;

  //:id is the fieldname id
  SQLQuery1.deleteSQL.Text := 'delete from table1 where id=:id';
  //:name is the fieldname name
  SQLQuery1.updateSQL.Text := 'update table1 set name=:name where id=:id';

  DataSource1.DataSet := SQLQuery1;
  DBGrid1.DataSource := DataSource1;
  DBGrid1.ReadOnly := true;

  DBEdit1.DataField := 'id';
  DBEdit1.DataSource := DataSource1;
  DBEdit2.DataField := 'name';
  DBEdit2.DataSource := DataSource1;

  SQLQuery1.Open;
end;

procedure TForm1.SQLQuery1AfterOpen(DataSet: TDataSet);
var
i : Integer;   //diese Funktion wandelt die Umlaute um
begin
for i:=0 to DataSet.Fields.Count-1 do
 begin
   if DataSet.Fields[i].DataType=ftString then
     begin
       DataSet.Fields[i].OnGetText:=@Text_von_DB_umwandeln;
       DataSet.Fields[i].OnSetText:=@Text_nach_DB_umwandeln;
     end;
 end;
end;

function MulDiv(nNumber, nNumerator, nDenominator: Integer): Integer;
begin
  Result:=Round(int64(nNumber)*int64(nNumerator)/nDenominator);
end;
procedure TForm1.PrintDbGrid(dbGrid:TdbGrid);
const
  LeftMargin = 0.05;
  TopMargin = 0.05;
  BottomMargin = 0.05;
var
  i: integer;
  x,y: integer;
begin
  if PrintDialog1.Execute then
    begin
    Printer.BeginDoc;
    Printer.Canvas.Font.Size := 12;

    y := Round(TopMargin*Printer.PageHeight);
    dbGrid.DataSource.DataSet.First;
    while not dbGrid.DataSource.DataSet.Eof do
      begin
      x := Round(LeftMargin*Printer.PageWidth);
      for i := 0 to dbGrid.DataSource.DataSet.FieldCount-1 do
        begin
        printer.Canvas.TextOut(x,y,dbGrid.DataSource.DataSet.Fields[i].AsString);
        x := x + MulDiv(dbGrid.Columns[i].Width,72, dbGrid.Width);
        end;
      dbGrid.DataSource.DataSet.Next;
      y := y + printer.Canvas.TextHeight('A');
      if y > (1-TopMargin-BottomMargin)* Printer.PageHeight then
        begin
        y := Round(TopMargin*Printer.PageHeight);
        Printer.NewPage;
        end;
      end;
    Printer.EndDoc;
    end
    else
    Form1.caption := 'NO PRINTER INSTALLED';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
PrintDbGrid(DBGrid1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if button2.Caption = 'new' then
begin
  SQLQuery1.Insert;
  button2.Caption := 'save';
  exit
  end
  else
  begin
    if (dbedit2.Text = '') //(dbedit1.Text = '') or (dbedit2.Text = '')
    then
    begin
    SQLQuery1.Cancel;
    end
    else
    begin
    if SQLQuery1.State = dsInsert then
       begin
       SQLQuery1.Post;
       SQLQuery1.ApplyUpdates;
       Form1.caption := 'ADDED';
       end;
    end;
  end;
button2.Caption := 'new';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if SQLQuery1.RecordCount>0 then
  begin
  SQLQuery1.Delete;
  SQLQuery1.ApplyUpdates;
  SQLQuery1.Close;
  SQLQuery1.Open;
  Form1.caption := 'DELETED';
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if SQLQuery1.RecordCount>0 then
  begin
   SQLQuery1.Edit;
   SQLQuery1.Post;
   Sqlquery1.ApplyUpdates;
   Form1.caption := 'UPDATED';
   end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
    SQLQuery1.Close;
    CanClose := True;
end;

procedure TForm1.Text_von_DB_umwandeln(Sender: TField; var aText: string; DisplayText: BOOLEAN);
begin
  if Sender.AsString <> '' then aText := UTF8Encode(Sender.AsString);
end;

procedure TForm1.Text_nach_DB_umwandeln(Sender: TField; const aText: string);
begin
  if aText <> '' then Sender.Value := UTF8Decode(aText);
end;

initialization
  {$I unit1.lrs}

end.

